<template class="w-4/4">
    <div class="p-5">
        <div class="w-1/4 m-auto">
            <label class="block text-gray-700 text-sm font-bold mb-2">
                Search an element
            </label>
            <input type="text"
                   placeholder="Select a color..."
                   class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
                   v-model="txtSearch"
                   @input="searchColor($event)"
            >
            <div v-if="colorsToDisplay.length" class="animated bg-blue-200 h-40 overflow-y-scroll"
                 v-bind:class="{'fadeIn': colorsToDisplay.length, 'fadeOut': !colorsToDisplay.length}">
                <p v-for="(color,index) in colorsToDisplay" v-bind:key="index" @click="selectColor(color)"
                   class="text-gray-700 font-bold cursor-p p-1">{{color}}</p>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "AutoCompleter",
        data: () => {
            return {
                txtSearch: '',
                emojis: ['😀', '😀', '🤖', '😊', '🤑', '😁', '🤓', '🧐', '🤠', '🤡', '👌', '👶', '👦', '🙋', '️🧠', '🤘',
                    '🤟', '🤚', '🖖', '🤙', '😠', '💩', '🤬', '☹', '😕', '😔', '👈', '👆', '👽'],
                colorsToDisplay: [],
                colors: [
                    'red',
                    'Beige',
                    'Bistre',
                    'Black',
                    'Blue',
                    'Blue Green',
                    'Blue Violet',
                    'Bondi Blue',
                    'Brass',
                    'Bronze',
                    'Brown',
                    'Buff',
                    'Burgundy',
                    'Burnt Orange',
                    'Burnt Sienna',
                    'Burnt Umber',
                    'Alizarin',
                    'Amaranth',
                    'Amber',
                    'Amethyst',
                    'Apricot',
                    'Aqua',
                    'Aquamarine',
                    'Asparagus',
                    'Auburn',
                    'Azure',
                    'Falu red',
                    'Fern green',
                    'Firebrick',
                    'Flax',
                    'Forest green',
                    'French Rose',
                    'Fuchsia',
                    'Lavender',
                    'Lawn green',
                    'Lemon',
                    'Lemon chiffon',
                    'Lilac',
                    'Lime',
                    'Lime green',
                    'Linen',
                    'Papaya whip',
                    'Peach',
                    'Pear',
                    'Periwinkle',
                    'Persimmon',
                    'Pine Green',
                    'Pink',
                    'Platinum',
                    'Plum',
                    'Powder blue',
                    'Puce',
                    'Prussian blue',
                    'Psychedelic purple',
                    'Pumpkin',
                    'Purple',
                    'Raw umber',
                    'Razzmatazz',
                    'Red',
                    'Robin egg blue',
                    'Rose',
                    'Royal blue',
                    'Royal purple',
                    'Ruby',
                    'Russet',
                    'Rust',
                    'Safety orange',
                    'Saffron',
                    'Salmon',
                    'Sandy brown',
                    'Sangria',
                    'Sapphire',
                    'Scarlet',
                    'School bus yellow',
                    'Sea Green',
                    'Seashell',
                    'Sepia',
                    'Shamrock green',
                    'Shocking Pink',
                    'Silver',
                    'Sky Blue',
                    'Slate grey',
                    'Smalt',
                    'Spring bud',
                    'Spring green',
                    'Steel blue',
                    'Tan',
                    'Tangerine',
                    'Taupe',
                    'Teal',
                    'Tenné (Tawny)',
                    'Terra cotta',
                    'Thistle',
                    'Titanium White',
                    'Tomato',
                    'Turquoise',
                    'Tyrian purple',
                    'Wheat',
                    'White',
                    'Wisteria',
                    'Van Dyke Brown',
                    'Vermilion',
                    'Violet',
                    'Viridian',
                    'Yellow',
                ]
            }
        },
        methods: {
            searchColor() {
                if (this.txtSearch.length)
                    this.colorsToDisplay = this.colors.filter(c => c.toUpperCase().includes(this.txtSearch.toUpperCase()))
                else
                    this.colorsToDisplay = []
            },
            selectColor(color) {
                this.$alertify.success('You picked ' + color + this.emojis[Math.floor(Math.random() * this.emojis.length - 2)]);
            }
        }
    }
</script>

<style scoped>
    .cursor-p {
        cursor: pointer;
    }
</style>